{{  VDIP1 First try.

}}
CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000

        RXF     = 8
        TXE     = 9
        VWR     = 11
        VRD     = 10
        RST     = 27


VAR
        long          dato[1500]   ' To store data that VDIP read from USB flash disk.
        long          temp        
        long          x
        long          y
        long          su
        long          sd
        long          speed
        byte          command[50]
                        
OBJ
  tv          : "tv_text"
        
PUB start

   tv.start(12)
   tv.str(string("Vinculum Test...... ",13))

outa[RST]~~
dira[RST]~~   ' Output

outa[RXF]~
outa[TXE]~
dira[RXF]~     ' Input
dira[TXE]~     ' Input

outa[VWR]~
outa[VRD]~~
dira[VWR]~~   ' Output
dira[VRD]~~   ' Output

outa[7..0]~
dira[7..0]~

x:=0

 !outa[RST]       '                                      
 !outa[RST]       '                                      
 tv.str(string("Reset Vinculum.... ",13))

'********************************************************************************
' READS     'Version and Device Detected P2' 
'********************************************************************************
   temp := INA[RXF]
   repeat while temp <> 0
    temp := INA[RXF]
 tv.str(string("Reading.... ",13))

    repeat 44
      temp := INA[RXF]
      repeat while temp <> 0
       temp := INA[RXF]
 
      !outa[VRD]       '                                      
      dato[x] := INA[7..0]                'To read data sent by the  VDIP
      !outa[VRD]       '                                                      
      x := x + 1

    x:=0
    repeat 44                     
     y := dato[x]       
     if y <> 0
       tv.out(y)       
     x := x + 1                            ' At this point we get the Firmware version and the device state.

' READS    ' No Upgrade nd D:\>" 
    temp := INA[RXF]
    repeat while temp <> 0
     temp := INA[RXF]

x:=0
dira[7..0]~
    temp := INA[RXF]
    repeat while temp <> 0
     temp := INA[RXF]

    repeat 16
      temp := INA[RXF]
      repeat while temp <> 0
       temp := INA[RXF]
 
      !outa[VRD]       '                                      
      dato[x] := INA[7..0]                'To read data sent by the  VDIP
      !outa[VRD]       '                                                      
      x := x + 1
      
    x:=0
    repeat 16                     
     y := dato[x]       
     tv.out(y)       
     x := x + 1                            ' At this point we get the Firmware version and the device state.

'********************************************************************************
' SENDING   COMMANDS    
'********************************************************************************

  dira[7..0]~~  'Change to outputs.

   temp := INA[TXE]
   repeat while temp <> 0
    temp := INA[TXE]

   repeat x from 0 to 3         ' Short Mode
    outa[7..0] := comm[x]
    pulse

   repeat x from 4 to 11        'Open file for read
    outa[7..0] := comm[x]
    pulse

   repeat x from 12 to 18       ' read n bytes
    outa[7..0] := comm[x]
    pulse

' tv.str(string(13,"Data read... ",13))

'********************************************************************************
' READS   seguido (deja el puntero en el lugar del archivo, donde habia terminado de leer)
'********************************************************************************
x:=0
dira[7..0]~    ' Change to inputs.

   repeat  21
      temp := INA[RXF]
      repeat while temp <> 0
       temp := INA[RXF]

      !outa[VRD]       '                                      
      dato[x] := INA[7..0]                'To read data sent by the  VDIP
      !outa[VRD]       '                                                      
      x := x + 1
'      tv.dec(x)

dira[7..0]~~  'Change to outputs.
   repeat x from 12 to 18       ' read n bytes
     outa[7..0] := comm[x]
     pulse

x:=21
dira[7..0]~    ' Change to inputs.

   repeat  17 
      temp := INA[RXF]
      repeat while temp <> 0
       temp := INA[RXF]

      !outa[VRD]       '                                      
      dato[x] := INA[7..0]                'To read data sent by the  VDIP
      !outa[VRD]       '                                                      
      x := x + 1
'      tv.dec(x)

   tv.out($0D)

    x:=0
    repeat 38
     y := dato[x]       
     if y <> 0
      tv.out(y)       
     x := x + 1
'********************************************************************************

 tv.str(string(13,"Ready... "))



repeat

PUB pulse
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

DAT
        comm    byte      $73,$63,$73,$0D,$0E,$20,$43,$2E,$62,$74,$78,$0D,$0B,$20,$00,$00,$00,$0F,$0D

   